import os, sys
from pathlib import Path
import boost_histogram as bh
import matplotlib.pyplot as plt
import numpy as np
from creader import ClusterFileReader

try: 
    base = Path(os.environ['MOENCH_DATA'])
except:
    print('MOENCH_DATA has to be defined to run examples')
    sys.exit(1)


fname = "Moench_LGAD_SIM_Nov22/moenchLGAD202211/clustW17new/beam_En800eV_-40deg_300V_10us_d0_f5_0.clust"
r = ClusterFileReader(base/fname)
hist1 = bh.Histogram(bh.axis.Regular(40, -2, 2**14))
i = 0
while (cl:=r.read(100)).size:
    hist1.fill(cl['data'].flat)
    print(i)
    i+=1



fig, ax = plt.subplots()
ax.bar(hist1.axes[0].centers, hist1.values(), width=hist1.axes[0].widths)
ax.set_yscale('log')
plt.show()
